Index: /trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/OffspringSelectionGP.cs
===================================================================
--- /trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/OffspringSelectionGP.cs	(revision 2340)
+++ /trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/OffspringSelectionGP.cs	(revision 2341)
@@ -29,198 +29,80 @@
 using HeuristicLab.Selection;
 using HeuristicLab.Selection.OffspringSelection;
+using HeuristicLab.Modeling;
+using HeuristicLab.DataAnalysis;
 
 namespace HeuristicLab.GP.StructureIdentification {
-  public class OffspringSelectionGP : StandardGP {
-    public override string Name { get { return "OffspringSelectionGP"; } }
+  public class OffspringSelectionGP : HeuristicLab.GP.Algorithms.OffspringSelectionGP, IAlgorithm {
+    public override string Name { get { return "OffspringSelectionGP - StructureIdentification"; } }
 
-    public virtual int MaxEvaluatedSolutions {
-      get { return GetVariableInjector().GetVariable("MaxEvaluatedSolutions").GetValue<IntData>().Data; }
-      set { GetVariableInjector().GetVariable("MaxEvaluatedSolutions").GetValue<IntData>().Data = value; }
+    public virtual int TargetVariable {
+      get { return ProblemInjector.GetVariableValue<IntData>("TargetVariable", null, false).Data; }
+      set { ProblemInjector.GetVariableValue<IntData>("TargetVariable", null, false).Data = value; }
     }
 
-    public virtual double SelectionPressureLimit {
-      get { return GetVariableInjector().GetVariable("SelectionPressureLimit").GetValue<DoubleData>().Data; }
-      set { GetVariableInjector().GetVariable("SelectionPressureLimit").GetValue<DoubleData>().Data = value; }
+    public virtual Dataset Dataset {
+      get { return ProblemInjector.GetVariableValue<Dataset>("Dataset", null, false); }
+      set { ProblemInjector.GetVariable("Dataset").Value = value; }
     }
 
-    public virtual double ComparisonFactor {
-      get { return GetVariableInjector().GetVariable("ComparisonFactor").GetValue<DoubleData>().Data; }
-      set { GetVariableInjector().GetVariable("ComparisonFactor").GetValue<DoubleData>().Data = value; }
+    public virtual IAnalyzerModel Model {
+      get {
+        if (!Engine.Terminated)
+          throw new InvalidOperationException("The algorithm is still running. Wait until the algorithm is terminated to retrieve the result.");
+        else
+          return CreateGPModel();
+      }
     }
 
-    public virtual double SuccessRatioLimit {
-      get { return GetVariableInjector().GetVariable("SuccessRatioLimit").GetValue<DoubleData>().Data; }
-      set { GetVariableInjector().GetVariable("SuccessRatioLimit").GetValue<DoubleData>().Data = value; }
+    public virtual double PunishmentFactor {
+      get { return GetVariableInjector().GetVariable("PunishmentFactor").GetValue<DoubleData>().Data; }
+      set { GetVariableInjector().GetVariable("PunishmentFactor").GetValue<DoubleData>().Data = value; }
     }
 
-    public override int MaxGenerations {
-      get { throw new NotSupportedException(); }
-      set { /* ignore */ }
-    }
-
-    public override int TournamentSize {
-      get { throw new NotSupportedException(); }
-      set { /* ignore */ }
+    public override IOperator ProblemInjector {
+      get { return GetProblemInjector().OperatorGraph.InitialOperator.SubOperators[0]; }
+      set {
+        value.Name = "ProblemInjector";
+        CombinedOperator problemInjector = GetProblemInjector();
+        problemInjector.OperatorGraph.RemoveOperator(ProblemInjector.Guid);
+        problemInjector.OperatorGraph.AddOperator(value);
+        problemInjector.OperatorGraph.InitialOperator.AddSubOperator(value, 0);
+      }
     }
 
     public OffspringSelectionGP()
       : base() {
-      PopulationSize = 1000;
-      Parents = 20;
-      MaxEvaluatedSolutions = 5000000;
-      SelectionPressureLimit = 400;
-      ComparisonFactor = 1.0;
-      SuccessRatioLimit = 1.0;
+      PunishmentFactor = 10.0;
     }
 
-    protected internal override IOperator CreateGlobalInjector() {
-      VariableInjector injector = (VariableInjector)base.CreateGlobalInjector();
-      injector.RemoveVariable("TournamentSize");
-      injector.RemoveVariable("MaxGenerations");
-      injector.AddVariable(new HeuristicLab.Core.Variable("MaxEvaluatedSolutions", new IntData()));
-      injector.AddVariable(new HeuristicLab.Core.Variable("ComparisonFactor", new DoubleData()));
-      injector.AddVariable(new HeuristicLab.Core.Variable("SelectionPressureLimit", new DoubleData()));
-      injector.AddVariable(new HeuristicLab.Core.Variable("SuccessRatioLimit", new DoubleData()));
+    protected override IOperator CreateFunctionLibraryInjector() {
+      return DefaultStructureIdentificationAlgorithmOperators.CreateFunctionLibraryInjector();
+    }
+
+    protected override IOperator CreateProblemInjector() {
+      return DefaultStructureIdentificationAlgorithmOperators.CreateProblemInjector();
+    }
+
+    protected override IOperator CreateInitialPopulationEvaluator() {
+      return DefaultStructureIdentificationAlgorithmOperators.CreateInitialPopulationEvaluator();
+    }
+
+    protected override IOperator CreateEvaluationOperator() {
+      return DefaultStructureIdentificationAlgorithmOperators.CreateEvaluator();
+    }
+
+
+    protected override IOperator CreateGenerationStepHook() {
+      return DefaultStructureIdentificationAlgorithmOperators.CreateGenerationStepHook();
+    }
+
+    protected override VariableInjector CreateGlobalInjector() {
+      VariableInjector injector = base.CreateGlobalInjector();
+      injector.AddVariable(new HeuristicLab.Core.Variable("PunishmentFactor", new DoubleData()));
       return injector;
     }
 
-    protected internal override IOperator CreateSelector() {
-      CombinedOperator selector = new CombinedOperator();
-      selector.Name = "Selector";
-      SequentialProcessor seq = new SequentialProcessor();
-      seq.Name = "Selector";
-      EmptyOperator emptyOp = new EmptyOperator();
-      ProportionalSelector femaleSelector = new ProportionalSelector();
-      femaleSelector.GetVariableInfo("Selected").ActualName = "Parents";
-      femaleSelector.GetVariableValue<BoolData>("CopySelected", null, false).Data = true;
 
-      RandomSelector maleSelector = new RandomSelector();
-      maleSelector.GetVariableInfo("Selected").ActualName = "Parents";
-      maleSelector.GetVariableValue<BoolData>("CopySelected", null, false).Data = true;
-      SequentialSubScopesProcessor seqSubScopesProc = new SequentialSubScopesProcessor();
-      RightChildReducer rightChildReducer = new RightChildReducer();
-      SubScopesMixer mixer = new SubScopesMixer();
-
-      seqSubScopesProc.AddSubOperator(femaleSelector);
-      seqSubScopesProc.AddSubOperator(emptyOp);
-
-      seq.AddSubOperator(maleSelector);
-      seq.AddSubOperator(seqSubScopesProc);
-      seq.AddSubOperator(rightChildReducer);
-      seq.AddSubOperator(mixer);
-
-      selector.OperatorGraph.AddOperator(seq);
-      selector.OperatorGraph.InitialOperator = seq;
-      return selector;
-    }
-
-    protected internal override IOperator CreateChildCreater() {
-      CombinedOperator childCreater = new CombinedOperator();
-      childCreater.Name = "Create children";
-      SequentialProcessor main = new SequentialProcessor();
-      SequentialProcessor seq = new SequentialProcessor();
-      SequentialProcessor offspringSelectionSeq = new SequentialProcessor();
-      OperatorExtractor selector = new OperatorExtractor();
-      selector.Name = "Selector (extr.)";
-      selector.GetVariableInfo("Operator").ActualName = "Selector";
-      SequentialSubScopesProcessor seqSubScopesProc = new SequentialSubScopesProcessor();
-      EmptyOperator emptyOp = new EmptyOperator();
-      OffspringSelector offspringSelector = new OffspringSelector();
-      ChildrenInitializer childInitializer = new ChildrenInitializer();
-      UniformSequentialSubScopesProcessor individualProc = new UniformSequentialSubScopesProcessor();
-      SequentialProcessor individualSeqProc = new SequentialProcessor();
-      OperatorExtractor crossover = new OperatorExtractor();
-      crossover.Name = "Crossover (extr.)";
-      crossover.GetVariableInfo("Operator").ActualName = "Crossover";
-      StochasticBranch cond = new StochasticBranch();
-      cond.GetVariableInfo("Probability").ActualName = "MutationRate";
-      OperatorExtractor manipulator = new OperatorExtractor();
-      manipulator.Name = "Manipulator (extr.)";
-      manipulator.GetVariableInfo("Operator").ActualName = "Manipulator";
-      OperatorExtractor evaluator = new OperatorExtractor();
-      evaluator.Name = "Evaluator (extr.)";
-      evaluator.GetVariableInfo("Operator").ActualName = "Evaluator";
-      Counter evalCounter = new Counter();
-      evalCounter.GetVariableInfo("Value").ActualName = "EvaluatedSolutions";
-      WeightedOffspringFitnessComparer offspringFitnessComparer = new WeightedOffspringFitnessComparer();
-      SubScopesRemover parentScopesRemover = new SubScopesRemover();
-
-      Sorter sorter = new Sorter();
-      sorter.GetVariableInfo("Descending").ActualName = "Maximization";
-      sorter.GetVariableInfo("Value").ActualName = "Quality";
-
-      UniformSequentialSubScopesProcessor validationEvaluator = new UniformSequentialSubScopesProcessor();
-      MeanSquaredErrorEvaluator validationQualityEvaluator = new MeanSquaredErrorEvaluator();
-      validationQualityEvaluator.Name = "ValidationMeanSquaredErrorEvaluator";
-      validationQualityEvaluator.GetVariableInfo("MSE").ActualName = "ValidationQuality";
-      validationQualityEvaluator.GetVariableInfo("SamplesStart").ActualName = "ValidationSamplesStart";
-      validationQualityEvaluator.GetVariableInfo("SamplesEnd").ActualName = "ValidationSamplesEnd";
-
-      main.AddSubOperator(seq);
-      seq.AddSubOperator(selector);
-      seq.AddSubOperator(seqSubScopesProc);
-      seqSubScopesProc.AddSubOperator(emptyOp);
-      seqSubScopesProc.AddSubOperator(offspringSelectionSeq);
-      seq.AddSubOperator(offspringSelector);
-      offspringSelector.AddSubOperator(seq);
-
-      offspringSelectionSeq.AddSubOperator(childInitializer);
-      offspringSelectionSeq.AddSubOperator(individualProc);
-      offspringSelectionSeq.AddSubOperator(sorter);
-
-      individualProc.AddSubOperator(individualSeqProc);
-      individualSeqProc.AddSubOperator(crossover);
-      individualSeqProc.AddSubOperator(cond);
-      cond.AddSubOperator(manipulator);
-      individualSeqProc.AddSubOperator(evaluator);
-      individualSeqProc.AddSubOperator(evalCounter);
-      individualSeqProc.AddSubOperator(offspringFitnessComparer);
-      individualSeqProc.AddSubOperator(parentScopesRemover);
-
-      SequentialSubScopesProcessor seqSubScopesProc2 = new SequentialSubScopesProcessor();
-      main.AddSubOperator(seqSubScopesProc2);
-      seqSubScopesProc2.AddSubOperator(emptyOp);
-
-      SequentialProcessor newGenProc = new SequentialProcessor();
-      newGenProc.AddSubOperator(sorter);
-      newGenProc.AddSubOperator(validationEvaluator);
-      seqSubScopesProc2.AddSubOperator(newGenProc);
-
-      validationEvaluator.AddSubOperator(validationQualityEvaluator);
-
-      childCreater.OperatorGraph.AddOperator(main);
-      childCreater.OperatorGraph.InitialOperator = main;
-      return childCreater;
-    }
-
-    protected internal override IOperator CreateLoopCondition(IOperator loop) {
-      SequentialProcessor seq = new SequentialProcessor();
-      seq.Name = "Loop Condition";
-      LessThanComparator generationsComparator = new LessThanComparator();
-      generationsComparator.GetVariableInfo("LeftSide").ActualName = "EvaluatedSolutions";
-      generationsComparator.GetVariableInfo("RightSide").ActualName = "MaxEvaluatedSolutions";
-      generationsComparator.GetVariableInfo("Result").ActualName = "EvaluatedSolutionsCondition";
-
-      LessThanComparator selPresComparator = new LessThanComparator();
-      selPresComparator.GetVariableInfo("LeftSide").ActualName = "SelectionPressure";
-      selPresComparator.GetVariableInfo("RightSide").ActualName = "SelectionPressureLimit";
-      selPresComparator.GetVariableInfo("Result").ActualName = "SelectionPressureCondition";
-
-      ConditionalBranch generationsCond = new ConditionalBranch();
-      generationsCond.GetVariableInfo("Condition").ActualName = "EvaluatedSolutionsCondition";
-
-      ConditionalBranch selPresCond = new ConditionalBranch();
-      selPresCond.GetVariableInfo("Condition").ActualName = "SelectionPressureCondition";
-
-      seq.AddSubOperator(generationsComparator);
-      seq.AddSubOperator(selPresComparator);
-      seq.AddSubOperator(generationsCond);
-      generationsCond.AddSubOperator(selPresCond);
-      selPresCond.AddSubOperator(loop);
-
-      return seq;
-    }
-
-    protected internal override IOperator CreateLoggingOperator() {
+    protected override IOperator CreateLoggingOperator() {
       CombinedOperator loggingOperator = new CombinedOperator();
       loggingOperator.Name = "Logging";
@@ -239,8 +121,6 @@
       QualityLogger qualityLogger = new QualityLogger();
       QualityLogger validationQualityLogger = new QualityLogger();
-      validationQualityLogger.Name = "ValidationQualityLogger";
       validationQualityLogger.GetVariableInfo("Quality").ActualName = "ValidationQuality";
       validationQualityLogger.GetVariableInfo("QualityLog").ActualName = "ValidationQualityLog";
-
       seq.AddSubOperator(collector);
       seq.AddSubOperator(qualityLogger);
@@ -252,19 +132,21 @@
     }
 
-
-    public override IEditor CreateEditor() {
-      return new OffspringSelectionGpEditor(this);
-    }
-
-    public override IView CreateView() {
-      return new OffspringSelectionGpEditor(this);
+    protected override IOperator CreatePostProcessingOperator() {
+      return DefaultStructureIdentificationAlgorithmOperators.CreatePostProcessingOperator();
     }
 
     public override object Clone(IDictionary<Guid, object> clonedObjects) {
       OffspringSelectionGP clone = (OffspringSelectionGP)base.Clone(clonedObjects);
-      clone.SelectionPressureLimit = SelectionPressureLimit;
-      clone.SuccessRatioLimit = SuccessRatioLimit;
-      clone.ComparisonFactor = ComparisonFactor;
+      clone.PunishmentFactor = PunishmentFactor;
       return clone;
+    }
+
+    protected CombinedOperator GetProblemInjector() {
+      return (CombinedOperator)GetInitializationOperator().SubOperators[0];
+    }
+
+    private IAnalyzerModel CreateGPModel() {
+      IScope bestModelScope = Engine.GlobalScope.SubScopes[0];
+      return DefaultStructureIdentificationAlgorithmOperators.CreateGPModel(bestModelScope);
     }
   }
Index: /trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/StandardGP.cs
===================================================================
--- /trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/StandardGP.cs	(revision 2340)
+++ /trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/StandardGP.cs	(revision 2341)
@@ -21,79 +21,51 @@
 
 using HeuristicLab.Core;
-using HeuristicLab.DataAnalysis;
 using HeuristicLab.Operators;
 using HeuristicLab.Selection;
 using HeuristicLab.Logging;
 using HeuristicLab.Data;
-using HeuristicLab.Operators.Programmable;
+using HeuristicLab.GP.Operators;
 using HeuristicLab.Modeling;
-using HeuristicLab.GP.Operators;
+using System.Collections.Generic;
+using System;
+using HeuristicLab.DataAnalysis;
 
 namespace HeuristicLab.GP.StructureIdentification {
-  public class StandardGP : AlgorithmBase, IEditable {
+  public class StandardGP : HeuristicLab.GP.Algorithms.StandardGP, IAlgorithm {
 
-    public override string Name { get { return "StandardGP"; } }
+    public override string Name { get { return "StandardGP - StructureIdentification"; } }
 
-    public override int TargetVariable {
+    public virtual int TargetVariable {
       get { return ProblemInjector.GetVariableValue<IntData>("TargetVariable", null, false).Data; }
       set { ProblemInjector.GetVariableValue<IntData>("TargetVariable", null, false).Data = value; }
     }
 
-    public override Dataset Dataset {
+    public virtual Dataset Dataset {
       get { return ProblemInjector.GetVariableValue<Dataset>("Dataset", null, false); }
       set { ProblemInjector.GetVariable("Dataset").Value = value; }
     }
 
-    public virtual int MaxGenerations {
-      get { return GetVariableInjector().GetVariable("MaxGenerations").GetValue<IntData>().Data; }
-      set { GetVariableInjector().GetVariable("MaxGenerations").GetValue<IntData>().Data = value; }
-    }
-
-    public virtual int TournamentSize {
-      get { return GetVariableInjector().GetVariable("TournamentSize").GetValue<IntData>().Data; }
-      set { GetVariableInjector().GetVariable("TournamentSize").GetValue<IntData>().Data = value; }
-    }
-
-    public double FullTreeShakingFactor {
-      get { return GetVariableInjector().GetVariable("FullTreeShakingFactor").GetValue<DoubleData>().Data; }
-      set { GetVariableInjector().GetVariable("FullTreeShakingFactor").GetValue<DoubleData>().Data = value; }
-    }
-
-    public double OnePointShakingFactor {
-      get { return GetVariableInjector().GetVariable("OnePointShakingFactor").GetValue<DoubleData>().Data; }
-      set { GetVariableInjector().GetVariable("OnePointShakingFactor").GetValue<DoubleData>().Data = value; }
-    }
-
-    public int MinInitialTreeSize {
-      get { return GetVariableInjector().GetVariable("MinInitialTreeSize").GetValue<IntData>().Data; }
-      set { GetVariableInjector().GetVariable("MinInitialTreeSize").GetValue<IntData>().Data = value; }
-    }
-
-    public override int MaxTreeSize {
+    public virtual IAnalyzerModel Model {
       get {
-        return base.MaxTreeSize;
-      }
-      set {
-        base.MaxTreeSize = value;
-        MinInitialTreeSize = value / 2;
+        if (!Engine.Terminated)
+          throw new InvalidOperationException("The algorithm is still running. Wait until the algorithm is terminated to retrieve the result.");
+        else
+          return CreateGPModel();
       }
     }
 
-    public override int PopulationSize {
-      get {
-        return base.PopulationSize;
-      }
-      set {
-        base.PopulationSize = value;
-        Parents = 2 * value;
-      }
+    public virtual double PunishmentFactor {
+      get { return GetVariableInjector().GetVariable("PunishmentFactor").GetValue<DoubleData>().Data; }
+      set { GetVariableInjector().GetVariable("PunishmentFactor").GetValue<DoubleData>().Data = value; }
     }
 
     public override IOperator ProblemInjector {
-      get { return base.ProblemInjector.SubOperators[0]; }
+      get { return GetProblemInjector().OperatorGraph.InitialOperator.SubOperators[0]; }
       set {
         value.Name = "ProblemInjector";
-        base.ProblemInjector.RemoveSubOperator(0);
-        base.ProblemInjector.AddSubOperator(value, 0);
+        CombinedOperator problemInjector = GetProblemInjector();
+        problemInjector.OperatorGraph.RemoveOperator(ProblemInjector.Guid);
+        problemInjector.OperatorGraph.AddOperator(value);
+        problemInjector.OperatorGraph.InitialOperator.AddSubOperator(value, 0);
       }
     }
@@ -101,107 +73,36 @@
     public StandardGP()
       : base() {
-      PopulationSize = 10000;
-      MaxGenerations = 500;
-      TournamentSize = 7;
-      MutationRate = 0.15;
-      Elites = 1;
-      MaxTreeSize = 100;
-      MaxTreeHeight = 10;
-      FullTreeShakingFactor = 0.1;
-      OnePointShakingFactor = 1.0;
-      UseEstimatedTargetValue = false;
-      SetSeedRandomly = true;
+
+      PunishmentFactor = 10.0;
     }
 
-    protected internal override IOperator CreateProblemInjector() {
-      SequentialProcessor seq = new SequentialProcessor();
-      var probInject = new ProblemInjector();
-      probInject.GetVariableInfo("MaxNumberOfTrainingSamples").Local = true;
-      probInject.AddVariable(new HeuristicLab.Core.Variable("MaxNumberOfTrainingSamples", new IntData(5000)));
-
-      var shuffler = new DatasetShuffler();
-      shuffler.GetVariableInfo("ShuffleStart").ActualName = "TrainingSamplesStart";
-      shuffler.GetVariableInfo("ShuffleEnd").ActualName = "TrainingSamplesEnd";
-
-      seq.AddSubOperator(probInject);
-      seq.AddSubOperator(shuffler);
-      return seq;
+    protected override IOperator CreateFunctionLibraryInjector() {
+      return DefaultStructureIdentificationAlgorithmOperators.CreateFunctionLibraryInjector();
     }
 
-    protected internal override IOperator CreateSelector() {
-      TournamentSelector selector = new TournamentSelector();
-      selector.Name = "Selector";
-      selector.GetVariableInfo("Selected").ActualName = "Parents";
-      selector.GetVariableInfo("GroupSize").Local = false;
-      selector.RemoveVariable("GroupSize");
-      selector.GetVariableInfo("GroupSize").ActualName = "TournamentSize";
-      return selector;
+    protected override IOperator CreateProblemInjector() {
+      return DefaultStructureIdentificationAlgorithmOperators.CreateProblemInjector();
     }
 
-    protected internal override IOperator CreateGlobalInjector() {
-      VariableInjector globalInjector = (VariableInjector)base.CreateGlobalInjector();
-      globalInjector.AddVariable(new HeuristicLab.Core.Variable("TournamentSize", new IntData()));
-      globalInjector.AddVariable(new HeuristicLab.Core.Variable("MaxGenerations", new IntData()));
-      globalInjector.AddVariable(new HeuristicLab.Core.Variable("FullTreeShakingFactor", new DoubleData()));
-      globalInjector.AddVariable(new HeuristicLab.Core.Variable("OnePointShakingFactor", new DoubleData()));
-      globalInjector.AddVariable(new HeuristicLab.Core.Variable("MinInitialTreeSize", new IntData()));
-      return globalInjector;
+    protected override IOperator CreateInitialPopulationEvaluator() {
+      return DefaultStructureIdentificationAlgorithmOperators.CreateInitialPopulationEvaluator();
     }
 
-    protected internal override IOperator CreateCrossover() {
-      StandardCrossOver crossover = new StandardCrossOver();
-      crossover.Name = "Crossover";
-      return crossover;
+    protected override IOperator CreateEvaluationOperator() {
+      return DefaultStructureIdentificationAlgorithmOperators.CreateEvaluator();
     }
 
-    protected internal override IOperator CreateTreeCreator() {
-      ProbabilisticTreeCreator treeCreator = new ProbabilisticTreeCreator();
-      treeCreator.Name = "Tree generator";
-      treeCreator.GetVariableInfo("MinTreeSize").ActualName = "MinInitialTreeSize";
-      return treeCreator;
+
+    protected override IOperator CreateGenerationStepHook() {
+      return DefaultStructureIdentificationAlgorithmOperators.CreateGenerationStepHook();
     }
 
-    protected internal override IOperator CreateFunctionLibraryInjector() {
-      FunctionLibraryInjector funLibInjector = new FunctionLibraryInjector();
-      funLibInjector.GetVariableValue<BoolData>("Xor", null, false).Data = false;
-      funLibInjector.GetVariableValue<BoolData>("Average", null, false).Data = false;
-      return funLibInjector;
+    protected override VariableInjector CreateGlobalInjector() {
+      VariableInjector injector = base.CreateGlobalInjector();
+      injector.AddVariable(new HeuristicLab.Core.Variable("PunishmentFactor", new DoubleData()));
+      return injector;
     }
 
-    protected internal override IOperator CreateManipulator() {
-      CombinedOperator manipulator = new CombinedOperator();
-      manipulator.Name = "Manipulator";
-      StochasticMultiBranch multibranch = new StochasticMultiBranch();
-      FullTreeShaker fullTreeShaker = new FullTreeShaker();
-      fullTreeShaker.GetVariableInfo("ShakingFactor").ActualName = "FullTreeShakingFactor";
-
-      OnePointShaker onepointShaker = new OnePointShaker();
-      onepointShaker.GetVariableInfo("ShakingFactor").ActualName = "OnePointShakingFactor";
-      ChangeNodeTypeManipulation changeNodeTypeManipulation = new ChangeNodeTypeManipulation();
-      CutOutNodeManipulation cutOutNodeManipulation = new CutOutNodeManipulation();
-      DeleteSubTreeManipulation deleteSubTreeManipulation = new DeleteSubTreeManipulation();
-      SubstituteSubTreeManipulation substituteSubTreeManipulation = new SubstituteSubTreeManipulation();
-
-      IOperator[] manipulators = new IOperator[] {
-        onepointShaker, fullTreeShaker,
-        changeNodeTypeManipulation,
-        cutOutNodeManipulation,
-        deleteSubTreeManipulation,
-        substituteSubTreeManipulation};
-
-      DoubleArrayData probabilities = new DoubleArrayData(new double[manipulators.Length]);
-      for (int i = 0; i < manipulators.Length; i++) {
-        probabilities.Data[i] = 1.0;
-        multibranch.AddSubOperator(manipulators[i]);
-      }
-      multibranch.GetVariableInfo("Probabilities").Local = true;
-      multibranch.AddVariable(new HeuristicLab.Core.Variable("Probabilities", probabilities));
-
-      manipulator.OperatorGraph.AddOperator(multibranch);
-      manipulator.OperatorGraph.InitialOperator = multibranch;
-      return manipulator;
-    }
-
-    protected internal override IOperator CreateLoggingOperator() {
+    protected override IOperator CreateLoggingOperator() {
       CombinedOperator loggingOperator = new CombinedOperator();
       loggingOperator.Name = "Logging";
@@ -216,15 +117,10 @@
       names.Add(new StringData("AverageValidationQuality"));
       names.Add(new StringData("WorstValidationQuality"));
-      LinechartInjector lineChartInjector = new LinechartInjector();
-      lineChartInjector.GetVariableInfo("Linechart").ActualName = "Quality Linechart";
-      lineChartInjector.GetVariable("NumberOfLines").GetValue<IntData>().Data = 6;
+      names.Add(new StringData("EvaluatedSolutions"));
       QualityLogger qualityLogger = new QualityLogger();
       QualityLogger validationQualityLogger = new QualityLogger();
-      validationQualityLogger.Name = "ValidationQualityLogger";
       validationQualityLogger.GetVariableInfo("Quality").ActualName = "ValidationQuality";
       validationQualityLogger.GetVariableInfo("QualityLog").ActualName = "ValidationQualityLog";
-
       seq.AddSubOperator(collector);
-      seq.AddSubOperator(lineChartInjector);
       seq.AddSubOperator(qualityLogger);
       seq.AddSubOperator(validationQualityLogger);
@@ -235,10 +131,21 @@
     }
 
-    public virtual IEditor CreateEditor() {
-      return new StandardGpEditor(this);
+    protected override IOperator CreatePostProcessingOperator() {
+      return DefaultStructureIdentificationAlgorithmOperators.CreatePostProcessingOperator();
     }
 
-    public override IView CreateView() {
-      return new StandardGpEditor(this);
+    public override object Clone(IDictionary<Guid, object> clonedObjects) {
+      StandardGP clone = (StandardGP)base.Clone(clonedObjects);
+      clone.PunishmentFactor = PunishmentFactor;
+      return clone;
+    }
+
+    protected CombinedOperator GetProblemInjector() {
+      return (CombinedOperator)GetInitializationOperator().SubOperators[0];
+    }
+
+    private IAnalyzerModel CreateGPModel() {
+      IScope bestModelScope = Engine.GlobalScope.SubScopes[0];
+      return DefaultStructureIdentificationAlgorithmOperators.CreateGPModel(bestModelScope);
     }
   }
Index: /trunk/sources/HeuristicLab.LinearRegression/3.2/LinearRegression.cs
===================================================================
--- /trunk/sources/HeuristicLab.LinearRegression/3.2/LinearRegression.cs	(revision 2340)
+++ /trunk/sources/HeuristicLab.LinearRegression/3.2/LinearRegression.cs	(revision 2341)
@@ -125,5 +125,4 @@
       injector.AddVariable(new HeuristicLab.Core.Variable("PunishmentFactor", new DoubleData(1000)));
       injector.AddVariable(new HeuristicLab.Core.Variable("TotalEvaluatedNodes", new DoubleData(0)));
-      injector.AddVariable(new HeuristicLab.Core.Variable("UseEstimatedTargetValue", new BoolData(false)));
 
       return injector;
Index: /trunk/sources/HeuristicLab.sln
===================================================================
--- /trunk/sources/HeuristicLab.sln	(revision 2340)
+++ /trunk/sources/HeuristicLab.sln	(revision 2341)
@@ -251,4 +251,6 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Common-3.2", "HeuristicLab.Common\3.2\HeuristicLab.Common-3.2.csproj", "{1FC004FC-59AF-4249-B1B6-FF25873A20E4}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.GP.Algorithms-3.2", "HeuristicLab.GP.Algorithms\3.2\HeuristicLab.GP.Algorithms-3.2.csproj", "{3127719F-110E-4558-8845-98559DBB422D}"
 EndProject
 Global
@@ -4025,4 +4027,32 @@
 		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.Visualization Debug|x86.ActiveCfg = Debug|x86
 		{1FC004FC-59AF-4249-B1B6-FF25873A20E4}.Visualization Debug|x86.Build.0 = Debug|x86
+		{3127719F-110E-4558-8845-98559DBB422D}.CEDMA Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{3127719F-110E-4558-8845-98559DBB422D}.CEDMA Debug|Any CPU.Build.0 = Debug|Any CPU
+		{3127719F-110E-4558-8845-98559DBB422D}.CEDMA Debug|x64.ActiveCfg = Debug|Any CPU
+		{3127719F-110E-4558-8845-98559DBB422D}.CEDMA Debug|x86.ActiveCfg = Debug|Any CPU
+		{3127719F-110E-4558-8845-98559DBB422D}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{3127719F-110E-4558-8845-98559DBB422D}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{3127719F-110E-4558-8845-98559DBB422D}.Debug|x64.ActiveCfg = Debug|x64
+		{3127719F-110E-4558-8845-98559DBB422D}.Debug|x64.Build.0 = Debug|x64
+		{3127719F-110E-4558-8845-98559DBB422D}.Debug|x86.ActiveCfg = Debug|x86
+		{3127719F-110E-4558-8845-98559DBB422D}.Debug|x86.Build.0 = Debug|x86
+		{3127719F-110E-4558-8845-98559DBB422D}.Modeling Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{3127719F-110E-4558-8845-98559DBB422D}.Modeling Debug|Any CPU.Build.0 = Debug|Any CPU
+		{3127719F-110E-4558-8845-98559DBB422D}.Modeling Debug|x64.ActiveCfg = Debug|Any CPU
+		{3127719F-110E-4558-8845-98559DBB422D}.Modeling Debug|x86.ActiveCfg = Debug|x86
+		{3127719F-110E-4558-8845-98559DBB422D}.Modeling Debug|x86.Build.0 = Debug|x86
+		{3127719F-110E-4558-8845-98559DBB422D}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{3127719F-110E-4558-8845-98559DBB422D}.Release|Any CPU.Build.0 = Release|Any CPU
+		{3127719F-110E-4558-8845-98559DBB422D}.Release|x64.ActiveCfg = Release|x64
+		{3127719F-110E-4558-8845-98559DBB422D}.Release|x86.ActiveCfg = Release|x86
+		{3127719F-110E-4558-8845-98559DBB422D}.Release|x86.Build.0 = Release|x86
+		{3127719F-110E-4558-8845-98559DBB422D}.v3.2 Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{3127719F-110E-4558-8845-98559DBB422D}.v3.2 Debug|Any CPU.Build.0 = Debug|Any CPU
+		{3127719F-110E-4558-8845-98559DBB422D}.v3.2 Debug|x64.ActiveCfg = Debug|Any CPU
+		{3127719F-110E-4558-8845-98559DBB422D}.v3.2 Debug|x86.ActiveCfg = Debug|Any CPU
+		{3127719F-110E-4558-8845-98559DBB422D}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{3127719F-110E-4558-8845-98559DBB422D}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
+		{3127719F-110E-4558-8845-98559DBB422D}.Visualization Debug|x64.ActiveCfg = Debug|Any CPU
+		{3127719F-110E-4558-8845-98559DBB422D}.Visualization Debug|x86.ActiveCfg = Debug|Any CPU
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
@@ -4119,4 +4149,5 @@
 		{1263BB36-1F20-4960-A5CB-530746DBAD77} = {410732DB-725A-4824-896B-C298978343C0}
 		{1FC004FC-59AF-4249-B1B6-FF25873A20E4} = {410732DB-725A-4824-896B-C298978343C0}
+		{3127719F-110E-4558-8845-98559DBB422D} = {410732DB-725A-4824-896B-C298978343C0}
 		{A9E282EA-180F-4233-B809-AEDF0787545C} = {78982D7C-D63D-4A3D-AE1F-F58AC007603B}
 		{BF7D9494-A586-457B-8DF9-ED599F9E6A71} = {78982D7C-D63D-4A3D-AE1F-F58AC007603B}
